fs = require "fs"
vm = require "vm"
cs = require "coffee-script"
RouteContext = require "./route-context"

dk.plugin "routes", ["server", "assets", "template.helpers", "template.layout"], ->
  mod = {}
  allGetRoutes = {}
  routesPath = "#{process.cwd()}/routes.coffee"

  loadRoutes = ->
    js = cs.compile fs.readFileSync(routesPath).toString(), bare: true
    sandbox =
      dk: dk
      get: mod.get
      post: mod.post
      put: mod.put
      del: mod.del
      console: console
    vm.runInNewContext js, sandbox, "routes.vm"

  addRoute = (method, path, helper, func) ->
    if helper
      helpers = {}
      helpers["#{helper}Path"] = (options) ->
        renderedPath = path + ""
        for key, val of options
          renderedPath = renderedPath.replace ":#{key}", val
        renderedPath

      dk.template.helpers.add helpers

    dk.server[method] path, (req, res) ->
      func.call(new RouteContext(req, res))

  runHashBangFix = ->
    dk.server.use "/", (req, res, next) ->
      if escapedPath = req.param("_escaped_fragment_")
        req.url = decodeURIComponent escapedPath
      next()

  ["get", "post", "put", "del"].forEach (method) ->
    mod[method] = (path, helper, func) ->
      if helper.call # isFunction
        func = helper
        helper = null
      addRoute method, path, helper, func

  mod.config = (options) ->
    routesPath = options.path if options.path

  mod.run = ->
    loadRoutes()
    dk.assets.package "/js/sammy.js", "#{__dirname}/../public/js/sammy-0.7.0.js"
    dk.assets.package "/js/sammy.nested_params.js", "#{__dirname}/../public/js/sammy.nested_params.js"
    dk.assets.package "/js/dk-routes.js", "#{__dirname}/../public/js/dk-routes.coffee"
    dk.assets.package "/js/routes.js", ->
      js = cs.compile fs.readFileSync(routesPath).toString(), bare: true
      """
$(function() {
  var get = dk.routes.get;
  var post = dk.routes.post;
  var put = dk.routes.put;
  var del = dk.routes.del;

  #{js}

  dk.routes.run();
});
      """

  # This needs to be run before dk.server gets run
  runHashBangFix()

  mod
