dk.plugin "routes", ["template"], ->
  hasHistory = !!(window.history && history.pushState)
  sammy = Sammy()
  sammy.use Sammy.NestedParams
  sammy.notFound = (verb, path) ->
    console.log "404 Error for", verb, path

  hashBangify = (path) ->
    if hasHistory || /^\w+:\/\//.test(path)
      path
    else
      "#!" + path

  class RouteContext
    constructor: (@context) ->

    title: (str) ->
      $("title").html str

    description: (str) ->
      $("meta[name='description']").attr "content", str

    params: (name) ->
      @context.params[name]

    render: (name, locals={}) ->
      this.update "body", name, locals

    update: (selector, name, locals={}) ->
      markup = dk.template.render name, locals
      $(selector).html markup
      $.event.trigger("dk.routes.update", [name, locals])

    redirect: (path) ->
      @context.redirect path


  addRoute = (method, helper, path, func) ->
    console.log "Adding", method, helper, path
    if helper
      helpers = {}
      helpers["#{helper}Path"] = (options) ->
        renderedPath = path + ""
        for key, val of options
          renderedPath = renderedPath.replace ":#{key}", val
        renderedPath
      dk.template.helpers.add helpers

    sammy.route method, hashBangify(path), (context) ->
      console.log "hit route, path is #{context.path} and id is #{context.params.id}"
      func.call new RouteContext(context)
      return false # prevent default behaviors

  ["get", "post", "put", "del"].forEach (method) ->
    this[method] = (path, helper, func) ->
      if _.isFunction helper
        func = helper
        helper = null

      addRoute method, helper, path, func

  run = ->
    console.log "Running"
    if hasHistory
      sammy.run()
    else
      sammy.run("#!/")

    if !hasHistory
      $("a").live "click", (e) ->
        $this = $(this)
        newHref = hashBangify $this.attr("href")
        $this.attr "href", newHref

  return get:get, post:post, put:put, del:del, run:run
